-- Turbine Imports..
import "Turbine";
import "Turbine.Gameplay";
import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Turbine.Animation";
import "TempleDog.CJTome.CJTome";
import "TempleDog.CJTome.CJIcons";
import "TempleDog.CJTome.menu";
import "TempleDog.CJTome.Button";
import "TempleDog.CJTome.options";
import "Deusdictum.UI.DragBar";

player = Turbine.Gameplay.LocalPlayer.GetInstance();

-- Load and save settings
function loadSettings()
cjtSettings=Turbine.PluginData.Load( Turbine.DataScope.Character, "CJTome" );
if ( type( cjtSettings ) ~= "table" ) then
		cjtSettings = {bXset=800,bYset=20,cXset=(Turbine.UI.Display.GetWidth() / 2),cYset=(Turbine.UI.Display.GetHeight() / 2),filter=1};
	end
	if (cjtSettings.bXset == nil)then
		cjtSettings.bXset=800;
	end
	if (cjtSettings.bYset == nil)then
		cjtSettings.bYset=20;
	end
	return cjtSettings;
end

function saveSettings(bXcoord,bYcoord,cXcoord,cYcoord,WhichChecked)
	cjtSettings.bXset=bXcoord;
	cjtSettings.bYset=bYcoord;
	cjtSettings.cXset=cXcoord;
	cjtSettings.cYset=cYcoord;
	cjtSettings.filter=WhichChecked;
	Turbine.PluginData.Save( Turbine.DataScope.Character, "CJTome", cjtSettings );
end

--player = Turbine.Gameplay.LocalPlayer.GetInstance();

cjtSettings = loadSettings();
bXset = cjtSettings.bXset;
bYset = cjtSettings.bYset;
cXset = cjtSettings.cXset;
cYset = cjtSettings.cYset;
WhichChecked = cjtSettings.filter;

-- Draw the interface bar to the screen.

local gSlots = 6;
local CJText = "";
local CJTextD = "";

function drawCJSlots()

	-- Values for window and bar display.
	local backcolor = Turbine.UI.Color(0.0, 0.0, 0.0, 0.0);

	local slotSize = 32; -- 32 pixels is the size of the icons used.
	local slotPadding = 2; -- can be increased or decreased as wanted.
	local thumbsize = 23;
	local numSlots = 6; 

	local screenHeight = Turbine.UI.Display.GetHeight();
	local screenWidth = Turbine.UI.Display.GetWidth();

	local barWidth = (slotSize * numSlots) + (slotPadding * numSlots) + slotPadding;
	local barHeight = slotSize + (4 * slotPadding) + thumbsize + 8;

	local barLeft = (screenWidth / 2) - (barWidth / 2);
	local barTop = (screenHeight / 3) - (barHeight / 2);


	-- Parent Window for CJBar.
	CJTomeBar = Turbine.UI.Window();
	CJTomeBar:SetSize((barWidth + 4),(barHeight + 4));
	CJTomeBar:SetBackColor(Turbine.UI.Color(0.4,0,0,0));
	CJTomeBar:SetPosition(bXset, bYset);
	CJTomeBar:SetOpacity(1);
	CJTomeBar:SetMouseVisible(true);
	CJTomeBar:SetVisible(false);
	CJTomeBar:SetZOrder(1);
	CJTomeBar.DragBar = Deusdictum.UI.DragBar( CJTomeBar, "CJ Tome" );

	CJSlotBar = Turbine.UI.Window();
	CJSlotBar:SetParent(CJTomeBar);
	CJSlotBar:SetSize((barWidth),(barHeight));
	CJSlotBar:SetBackColor(backcolor);
	CJSlotBar:SetPosition(2, 2);
	CJSlotBar:SetOpacity(1);
	CJSlotBar:SetMouseVisible(false);
	CJSlotBar:SetVisible(false);

	CJLabel = Turbine.UI.Label();
	CJLabel:SetParent(CJSlotBar);
	CJLabel:SetPosition(5,2); -- 20,(barHeight-22)
	CJLabel:SetSize((barWidth - 10),14); -- (barWidth - 40),14)
	CJLabel:SetFont(Turbine.UI.Lotro.Font.Verdana12); -- Verdana12
	CJLabel:SetText("Right-click here");
	CJLabel:SetVisible(true);
	CJLabel:SetMouseVisible(true);
	CJLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
	CJLabel:SetBackColor(Turbine.UI.Color(0.6, 0.0, 0.0, 0.0));

	CJLabel2 = Turbine.UI.Label();
	CJLabel2:SetParent(CJSlotBar);
	CJLabel2:SetPosition(5,52); -- 20,(barHeight-22)
	CJLabel2:SetSize((barWidth - 10),16); -- (barWidth - 40),14)
	CJLabel2:SetFont(Turbine.UI.Lotro.Font.Verdana16); -- Verdana12
	CJLabel2:SetText("");
	CJLabel2:SetVisible(true);
	CJLabel2:SetMouseVisible(true);
	CJLabel2:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
	CJLabel2:SetBackColor(Turbine.UI.Color(0.6, 0.0, 0.0, 0.0));

	CJSlotsL = Turbine.UI.Label();
	CJSlotsL:SetParent(CJSlotBar);
	CJSlotsL:SetPosition(0,16);
	CJSlotsL:SetSize((barWidth),36);
	CJSlotsL:SetVisible(true);
	CJSlotsL:SetMouseVisible(false);
	CJSlotsL:SetBackColor(Turbine.UI.Color(0.0, 0.0, 0.0, 0.0));

	-- Create a quickslot for the shortcut
	local currentSlot = 1;
	CJSlots = {};

	while currentSlot <= numSlots do
		CJSlots[currentSlot] = Turbine.UI.Label();
		CJSlots[currentSlot]:SetParent(CJSlotsL);
		CJSlots[currentSlot]:SetSize(slotSize, slotSize);
		CJSlots[currentSlot]:SetLeft((slotPadding * currentSlot) + ((currentSlot - 1) * slotSize));
		CJSlots[currentSlot]:SetTop(slotPadding); -- added 20
		CJSlots[currentSlot]:SetFont(Turbine.UI.Lotro.Font.Verdana18);

		currentSlot = currentSlot + 1;
	end

	CJLabel.MouseDown = function(sender, args)

		if (args.Button == Turbine.UI.MouseButton.Right) then
			if (not player:IsInCombat() ) then
				displayMenu(); -- This function loads the Menu.
			end
		end

		if (args.Button == Turbine.UI.MouseButton.Left) then
			cX, cY = CJClose:GetPosition();
			bX, bY = CJTomeBar:GetPosition();
			WhichChecked = Setting;
			saveSettings( bX, bY, cX, cY, WhichChecked );
		end
	end

	CJLabel2.MouseDown = function(sender, args)

		if (args.Button == Turbine.UI.MouseButton.Right) then
			cjTTip:SetVisible(false);
		end

		if (args.Button == Turbine.UI.MouseButton.Left) then
			cX, cY = CJClose:GetPosition();
			bX, bY = CJTomeBar:GetPosition();
			WhichChecked = Setting;
			saveSettings( bX, bY, cX, cY, WhichChecked );
			if (not player:IsInCombat() ) then
				if (CJTextD ~= "" ) then
					Turbine.Shell.WriteLine(cjSets[cjCode].Name .. " - [ " .. CJTextD .. "]");
					cjTTip:SetVisible(true);
				end
			end
		end
	end
end

function setBarShortcuts(gCode)
	if gCode == nil then

	else
		-- Load the shortcuts
		cjCode = gCode;
		local numSlots = 7;
		local currentSlot = 1;
		
		-- Loop between slots filling the shortcuts in.
		while currentSlot < numSlots do
			local fmIcon = cjSets[cjCode].Colours[currentSlot];
			local cjName = cjSets[cjCode].Name;
			local cjThumb = "TempleDog/CJTome/Resources/" .. cjIcons[fmIcon].thumb;
			local cjNote = cjIcons[fmIcon].note;
			
			if (cjCode >= 5 and ( cjSets[cjCode].Filter == 1 or cjSets[cjCode].Filter == 2 or cjSets[cjCode].Filter == 4 ) ) then
				CJSlotsL:SetPosition(16,16);
			else
				CJSlotsL:SetPosition(0,16);
			end

			-- Need to test that the slot needs to be filled and blank then hide if not
			if fmIcon == 0 then
				-- No shortcut
				CJSlots[currentSlot]:SetBackground(cjThumb);
				CJSlots[currentSlot]:SetVisible( false);
				currentSlot = currentSlot + 1;
			else
				-- Fill shortcut unhide first
				CJSlots[currentSlot]:SetVisible( true );
				CJSlots[currentSlot]:SetBackground(cjThumb);
				CJText = CJText .. "  " .. cjNote .. "  ";
				currentSlot = currentSlot + 1;
			end
			CJLabel:SetText(cjName);
			CJTextD = CJText;
			CJLabel2:SetText(CJTextD);
		end
	CJText = "";
	Turbine.Shell.WriteLine(cjSets[cjCode].Name .. " - [ " .. CJTextD .. "]");
	end
end

Turbine.Shell.WriteLine("CJTome v2.0.3 by Templedog - enjoy ;-)");

CJOptions();
ToggleCheckBoxes()
SetCheckBoxes();
CJTomeButton();
drawCJSlots();
createMenu();
CJTomeBar:SetVisible( false );
